Public Class Form1
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim computer_info As New Devices.ComputerInfo
        AddItem(lvProperties, "InstalledUICulture", computer_info.InstalledUICulture.DisplayName)
        AddItem(lvProperties, "OSFullName", computer_info.OSFullName)
        AddItem(lvProperties, "OSPlatform", computer_info.OSPlatform)
        AddItem(lvProperties, "OSVersion", computer_info.OSVersion)
        AddItem(lvMemory, "AvailablePhysicalMemory", FormatBigBytes(computer_info.AvailablePhysicalMemory, 2))
        AddItem(lvMemory, "AvailableVirtualMemory", FormatBigBytes(computer_info.AvailableVirtualMemory, 2))
        AddItem(lvMemory, "TotalPhysicalMemory", FormatBigBytes(computer_info.TotalPhysicalMemory, 2))
        AddItem(lvMemory, "TotalVirtualMemory", FormatBigBytes(computer_info.TotalVirtualMemory, 2))
    End Sub

    Private Sub AddItem(ByVal lv As ListView, ByVal item_name As String, ByVal item_value As String)
        Dim lv_item As ListViewItem = lv.Items.Add(item_name)
        lv_item.SubItems.Add(item_value)
    End Sub

    ' Return a string representing the number in KB, MG, GB, etc.
    Private Function FormatBigBytes(ByVal num As Double, ByVal digits As Integer) As String
        Dim postfixes() As String = {"bytes", "KB", "MB", "GB", "TB", "PB", "EB", "ZB", "YB"}
        For i As Integer = 0 To postfixes.Length - 1
            If num < 1024 Then
                Return FormatNumber(num, digits) & " " & postfixes(i)
            End If
            num /= 1024
        Next i

        Return FormatNumber(num * 1024, digits) & " " & postfixes(postfixes.Length - 1)
    End Function
End Class
